#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <readline/readline.h>
#include <readline/history.h>

static rl_hook_func_t my_hook;
static int sigint_caught = 0;
static void my_sigint(int signo)
{
  if( signo == SIGINT )
    sigint_caught = 1;
}
static int my_hook(void)
{
  if( sigint_caught )
    rl_done = 1, sigint_caught = 0;
  return 1;
}

int main(int argc, char **argv)
{
  signal(SIGINT, my_sigint);
  setbuf(stdin, NULL); // ensure no buffering on stdin when interactive

  if( !rl_outstream ) {
    rl_outstream = stderr;
    rl_event_hook = my_hook;
    rl_initialize();
  }

  for(;;) {
    char *sz = readline("myapp> ");
    if( !sz ) {
      /* exit condition */
      fprintf(stderr, "exiting\n");
      break;
    }
    fprintf(stderr, "got <%s>\n", sz);
    if( sz )
      add_history(sz);
    free(sz);
  }

  return EXIT_SUCCESS;
}
